/*

  Copyright (C) 2003-2004 Smardec. All rights reserved.

  http://www.smardec.com

*/

package com;

import com.smardec.asc.autocomplete.JAutoComboBox;
import com.smardec.asc.autocomplete.JAutoTextField;
import com.smardec.asc.gradient.SmartGradientPaint;
import com.smardec.asc.outlookpanel.JOutlookButton;
import com.smardec.asc.outlookpanel.JOutlookPanel;
import com.smardec.asc.outlookpanel.JOutlookTab;
import com.smardec.asc.outlookpanel.renderers.DefaultOutlookButtonRenderer;
import com.smardec.asc.outlookpanel.renderers.DefaultOutlookScrollButtonRenderer;
import com.smardec.asc.outlookpanel.renderers.blueplastic.BluePlasticOutlookTabBodyRenderer;
import com.smardec.asc.outlookpanel.renderers.blueplastic.BluePlasticOutlookTabHeaderRenderer;
import com.smardec.asc.outlookpanel.renderers.metalwood.MetalWoodOutlookTabBodyRenderer;
import com.smardec.asc.outlookpanel.renderers.metalwood.MetalWoodOutlookTabHeaderRenderer;
import com.smardec.asc.sliderpanel.JSliderPanel;
import com.smardec.asc.sliderpanel.JSliderPanelContainer;
import com.smardec.asc.tree.JSmartTree;
import com.smardec.asc.util.JMemoryIndicator;
import com.smardec.asc.util.JSplashScreen;

import javax.swing.*;
import javax.swing.table.TableCellEditor;
import java.awt.*;
import java.util.Arrays;


/*
    Sample of usage. The class cannot be compiled.
    It just contains code snippets and covers minimum of features.
*/

public class Demo extends JFrame {
    public static java.util.List languages = Arrays.asList(new Object[]{
        "Afrikaans", "Albanian", "Amharic", "Arabic", "Azerbaijani", "Basque", "Belarusian", "Bengali", "Bihari",
        "Bosnian", "Breton", "Bulgarian", "Catalan", "Chinese (Simplified)", "Chinese (Traditional)", "Croatian",
        "Czech", "Danish", "Dutch", "Elmer Fudd", "English", "Esperanto", "Estonian", "Faroese", "Filipino", "Finnish",
        "French", "Frisian", "Galician", "Georgian", "German", "Greek", "Guarani", "Gujarati", "Hebrew", "Hindi",
        "Hungarian", "Icelandic", "Indonesian", "Interlingua", "Irish", "Italian", "Japanese", "Javanese", "Kannada",
        "Klingon", "Korean", "Kyrgyz", "Latin", "Latvian", "Lithuanian", "Macedonian", "Malay", "Malayalam", "Maltese",
        "Marathi", "Nepali", "Norwegian", "Norwegian (Nynorsk)", "Occitan", "Oriya", "Persian", "Pig Latin", "Polish",
        "Portuguese (Brazil) ", "Portuguese (Portugal) ", "Punjabi", "Romanian", "Russian", "Scots Gaelic", "Serbian",
        "Serbo-Croatian", "Sesotho", "Sinhalese", "Slovak", "Slovenian", "Spanish", "Sundanese", "Swahili", "Swedish",
        "Tamil", "Telugu", "Thai", "Tigrinya", "Turkish", "Turkmen", "Twi", "Ukrainian", "Urdu", "Uzbek", "Vietnamese",
        "Welsh", "Xhosa", "Yiddish", "Zulu"
    });

    private void showSplash(int displayTime) {
        JSplashScreen splash = new JSplashScreen(this);
        splash.setImage(Demo.class.getClassLoader().getResource("com/smardec/asc/img/splash.jpg"));
        splash.setBorder(BorderFactory.createLineBorder(Color.black, 1));
        splash.setCloseOnClick(true);
        splash.setMinimumDisplayTime(0);
        splash.setDisplayTime(displayTime);
        splash.showSplash();
    }

    private void sampleOutlookPanelUsage() {
        JOutlookPanel jOutlookPanel = new JOutlookPanel();
        JOutlookTab jOutlookTab;

        jOutlookTab = new JOutlookTab("Tab 1", null);
        jOutlookTab.addButton(new JOutlookButton("First button", new ImageIcon(Demo.class.getClassLoader().getResource("com/smardec/asc/img/Mouse3d.gif"))));
        jOutlookTab.addButton(new JOutlookButton("Second button", new ImageIcon(Demo.class.getClassLoader().getResource("com/smardec/asc/img/Mouse3d.gif"))));
        jOutlookTab.addButton(new JOutlookButton("Third button", new ImageIcon(Demo.class.getClassLoader().getResource("com/smardec/asc/img/Mouse3d.gif"))));
        jOutlookTab.addButton(new JOutlookButton("Fourth button", new ImageIcon(Demo.class.getClassLoader().getResource("com/smardec/asc/img/Mouse3d.gif"))));
        jOutlookPanel.addTab(jOutlookTab);

        jOutlookTab = new JOutlookTab("Tab 2", null);
        jOutlookTab.addButton(new JOutlookButton("First button", new ImageIcon(Demo.class.getClassLoader().getResource("com/smardec/asc/img/Mouse3d.gif"))));
        jOutlookTab.addButton(new JOutlookButton("Second button", new ImageIcon(Demo.class.getClassLoader().getResource("com/smardec/asc/img/Mouse3d.gif"))));
        jOutlookPanel.addTab(jOutlookTab);

        jOutlookTab = new JOutlookTab("Tab 3", null);
        jOutlookTab.addButton(new JOutlookButton("First button", new ImageIcon(Demo.class.getClassLoader().getResource("com/smardec/asc/img/Mouse3d.gif"))));
        jOutlookTab.addButton(new JOutlookButton("Second button", new ImageIcon(Demo.class.getClassLoader().getResource("com/smardec/asc/img/Mouse3d.gif"))));
        jOutlookTab.addButton(new JOutlookButton("Third button", new ImageIcon(Demo.class.getClassLoader().getResource("com/smardec/asc/img/Mouse3d.gif"))));
        jOutlookTab.addButton(new JOutlookButton("Fourth button", new ImageIcon(Demo.class.getClassLoader().getResource("com/smardec/asc/img/Mouse3d.gif"))));
        jOutlookPanel.addTab(jOutlookTab);

        // you can also set predefined or your own renderers
        jOutlookPanel.setOutlookTabHeaderRenderer(new BluePlasticOutlookTabHeaderRenderer());
        jOutlookPanel.setOutlookTabBodyRenderer(new BluePlasticOutlookTabBodyRenderer());
        jOutlookPanel.setOutlookButtonRenderer(new DefaultOutlookButtonRenderer());
        jOutlookPanel.setTabSpacing(0);
        jOutlookPanel.setOutlookScrollButtonUpRenderer(new DefaultOutlookScrollButtonRenderer(imageIconScrollUpSelected, imageIconScrollUp));
        jOutlookPanel.setOutlookScrollButtonDownRenderer(new DefaultOutlookScrollButtonRenderer(imageIconScrollDownSelected, imageIconScrollDown));

        // animated
        jOutlookPanel.setDefaultPaintMode(JOutlookPanel.MODE_ANIMATE);
        // non-animated
        jOutlookPanel.setDefaultPaintMode(JOutlookPanel.MODE_DEFAULT);
    }

    private void sampleSliderUsage() {
        jSliderPanelContainer = new JSliderPanelContainer();
        jSliderPanelContainer.addBaseComponent(new JScrollPane(new JTree()));
        JPanel jPanelLeft = new JPanel();
        // show animated
        jSliderPanelContainer.showPanelLeft(jPanelLeft, JSliderPanel.MODE_ANIMATE);
        //show non-animated
        jSliderPanelContainer.showPanelLeft(jPanelLeft, JSliderPanel.MODE_DEFAULT);
    }

    private void sampleSmartTreeUsage() {
        // just create JSmartTree instead of JTree
        JTree jSmartTree = new JSmartTree();
    }

    private void sampleAutoCompleteUsage() {
        // creating text field with strict autocomplete
        JAutoTextField jAutoTextFieldStrict = new JAutoTextField(languages);
        // creating text field with non-strict autocomplete
        JAutoTextField jAutoTextFieldNonStrict = new JAutoTextField(languages);
        jAutoTextFieldNonStrict.setStrict(false);
        // creating combobox with strict autocomplete
        JAutoComboBox jAutoComboBoxStrict = new JAutoComboBox(languages);
        // creating combobox with non-strict autocomplete
        JAutoComboBox jAutoComboBoxNonStrict = new JAutoComboBox(languages);
        jAutoComboBoxNonStrict.setStrict(false);

        // using autocomplete components as editors in JTable
        JTable jTable = new JTable() {
            public TableCellEditor getCellEditor(int row, int column) {
                if (row == 0) {
                    JAutoTextField jAutoTextField = new JAutoTextField(languages);
                    return new DefaultCellEditor(jAutoTextField);
                } else {
                    JAutoComboBox jAutoComboBox = new JAutoComboBox(languages);
                    return new DefaultCellEditor(jAutoComboBox);
                }
            }
        };
    }

    private void sampleGradientUsage() {
        JPanel jPanelSmartGradient = new JPanel() {
            protected void paintComponent(Graphics g) {
                ((Graphics2D) g).setPaint(new SmartGradientPaint(Color.gray, Color.lightGray, false));
                ((Graphics2D) g).fill(new Rectangle(getSize()));
            }
        };
    }
}
